Loading...
Searching...
No Matches
BALL::ForceFieldComponent Class Reference
Molecular Modeling » Molecular Mechanics » General Force Field Classes.

`#include <BALL/MOLMEC/COMMON/forceFieldComponent.h>`

Inheritance diagram for BALL::ForceFieldComponent:

## Public Member Functions

Constructors and Destructors
| ForceFieldComponent ()
| ForceFieldComponent (ForceField &force_field)
| ForceFieldComponent (const ForceFieldComponent &force_field_component)
virtual | ~ForceFieldComponent ()
Setup method
virtual bool | setup ()
Accessors
ForceField * | getForceField () const
void | setForceField (ForceField &force_field)
void | setName (const String &name)
String | getName () const
bool | isEnabled () const
void | setEnabled (bool state)
Public Member Functions inherited from BALL::ScoringComponent
| ScoringComponent ()
| ScoringComponent (const ScoringComponent &sc)
| ScoringComponent (ScoringFunction &sf)
void | selectBaseFunction (String function)
virtual | ~ScoringComponent ()
virtual void | clear ()
virtual void | setupLigand ()
ScoringFunction * | getScoringFunction () const
void | setScoringFunction (ScoringFunction &sf)
String | getName () const
void | setName (const String &name)
const String & | getTypeName ()
double | getRawScore () const
double | getScaledScore () const
virtual void | update (const vector< std::pair< Atom *, Atom * > > &pair_vector)
virtual void | setLigandIntraMolecular (bool b)
bool | isLigandIntraMolecular ()
bool | isGridable ()
bool | isAtomPairwise ()
void | setCoefficient (const double &coeff)
const double & | getCoefficient ()
void | setNormalizationParameters (double stddev, double mean)
void | getNormalizationParameters (double &stddev, double &mean)
bool | isEnabled ()
void | enable ()
void | disable ()

## Friends

class | ForceField

## Force field calculations

ForceField * | force_field_
double | energy_
virtual double | getEnergy () const
virtual double | updateEnergy ()
virtual void | updateForces ()
virtual void | update ()
double | updateScore ()

## Additional Inherited Members

Protected Member Functions inherited from BALL::ScoringComponent
double | scaleScore (double score) const
Protected Attributes inherited from BALL::ScoringComponent
bool | ligand_intra_molecular_
bool | gridable_
bool | atom_pairwise_
ScoringFunction * | scoring_function_
ScoringBaseFunction * | base_function_
double | score_
double | coefficient_
double | stddev_
double | mean_
bool | enabled_
String | type_name_

## Detailed Description

Generic force field component class.

Definition at line 34 of file forceFieldComponent.h.

## Constructor & Destructor Documentation

## ForceFieldComponent() [1/3]

BALL::ForceFieldComponent::ForceFieldComponent | ( |  | ) |

Default constructor.

## ForceFieldComponent() [2/3]

BALL::ForceFieldComponent::ForceFieldComponent | ( | ForceField & | force_field | ) |

Constructor.

## ForceFieldComponent() [3/3]

BALL::ForceFieldComponent::ForceFieldComponent | ( | const ForceFieldComponent & | force_field_component | ) |

Copy constructor. Creates a new instance of the given ForceFieldComponent. The created object will not be assigned to an existing force field.

## ~ForceFieldComponent()

virtual BALL::ForceFieldComponent::~ForceFieldComponent | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## getEnergy()

virtual double BALL::ForceFieldComponent::getEnergy | ( |  | ) | const

virtual

Returns the energy of the force field component

## getForceField()

ForceField * BALL::ForceFieldComponent::getForceField | ( |  | ) | const

Returns the parent force field. 0 is returned, if no force field is assigned.

## getName()

String BALL::ForceFieldComponent::getName | ( |  | ) | const

Returns the component's name

## isEnabled()

bool BALL::ForceFieldComponent::isEnabled | ( |  | ) | const

inline

Definition at line 100 of file forceFieldComponent.h.

## setEnabled()

void BALL::ForceFieldComponent::setEnabled | ( | bool | state | ) |

inline

Definition at line 103 of file forceFieldComponent.h.

## setForceField()

void BALL::ForceFieldComponent::setForceField | ( | ForceField & | force_field | ) |

Sets the force field.

## setName()

void BALL::ForceFieldComponent::setName | ( | const String & | name | ) |

Sets the component's name.

## setup()

virtual bool BALL::ForceFieldComponent::setup | ( |  | ) |

virtual

Setup method.

Reimplemented from BALL::ScoringComponent.

Reimplemented in BALL::AmberBend, BALL::AmberNonBonded, BALL::AmberStretch, BALL::AmberTorsion, BALL::CharmmBend, BALL::CharmmImproperTorsion, BALL::CharmmNonBonded, BALL::CharmmStretch, BALL::CharmmTorsion, BALL::MMFF94NonBonded, BALL::MMFF94OutOfPlaneBend, BALL::MMFF94StretchBend, and BALL::MMFF94Torsion.

## update()

virtual void BALL::ForceFieldComponent::update | ( |  | ) |

virtual

Regular update of the pair list and the like. Each component that contains updatable data structures (like nonbonded pair lists) should implement this method. It is called for each component of a force field each time ForceField::update is called. The default implementation does exactly nothing.

Exceptions

  BALL::Exception::TooManyErrors |

Reimplemented in BALL::AmberNonBonded, BALL::MMFF94NonBonded, and BALL::PLP.

## updateEnergy()

virtual double BALL::ForceFieldComponent::updateEnergy | ( |  | ) |

virtual

Returns the energy of the force field component. The current energy for this force field component is being calculated and returned in units of kJ/mol.

  If the component isn't assigned to a ForceField object, zero is returned.

Reimplemented in BALL::AmberNonBonded, BALL::AmberTorsion, BALL::BendComponent, BALL::CharmmImproperTorsion, BALL::CharmmNonBonded, BALL::CharmmTorsion, BALL::MMFF94NonBonded, BALL::MMFF94OutOfPlaneBend, BALL::MMFF94StretchBend, BALL::MMFF94Torsion, BALL::PLP, and BALL::StretchComponent.

## updateForces()

virtual void BALL::ForceFieldComponent::updateForces | ( |  | ) |

virtual

Updates the atomic forces in the force field. The forces created by this ForceFieldComponent are calculated for each atom and updated in the corresponding array (forces) of the ForceField instance this component is assigned to.

Reimplemented in BALL::AmberNonBonded, BALL::AmberTorsion, BALL::BendComponent, BALL::CharmmImproperTorsion, BALL::CharmmNonBonded, BALL::CharmmTorsion, BALL::MMFF94NonBonded, BALL::MMFF94OutOfPlaneBend, BALL::MMFF94StretchBend, BALL::MMFF94Torsion, BALL::PLP, and BALL::StretchComponent.

## updateScore()

double BALL::ForceFieldComponent::updateScore | ( |  | ) |

virtual

interface to ScoringComponent

Reimplemented from BALL::ScoringComponent.

## Friends And Related Symbol Documentation

## ForceField

friend class ForceField

friend

Definition at line 37 of file forceFieldComponent.h.

## Member Data Documentation

## energy_

double BALL::ForceFieldComponent::energy_

protected

Definition at line 156 of file forceFieldComponent.h.

## force_field_

ForceField* BALL::ForceFieldComponent::force_field_

protected

Definition at line 152 of file forceFieldComponent.h.